	.386
	.model flat,stdcall
	option casemap:none
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\gdi32.inc
	include \masm32\include\comdlg32.inc
	include \masm32\include\shell32.inc
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\gdi32.lib
	includelib \masm32\lib\comdlg32.lib
	includelib \masm32\lib\shell32.lib
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
ColorDialog     PROTO :DWORD,:DWORD,:DWORD
RGB macro red,green,blue
	xor		eax,eax
	mov		ah,blue
	shl		eax,8
	mov		ah,green
	mov		al,red
endm
szText MACRO Name,Text:VARARG
	LOCAL	lbl
	jmp		lbl
	Name	db Text,0
	lbl:
ENDM
.const
button1ID		equ 2
.data?
hFontN			HWND ?
hwndbutton1		HWND ?
hInstance		HINSTANCE ?
CommandLine		LPSTR ?
.data
FontName		db "MS Sans Serif",0
lf				LOGFONT <>
Textbutton1		db "",0
;_______________
ClassName		db "MASM Builder",0
BtnClName		db "button",0
StatClName		db "static",0
EditClName		db "edit",0
LboxClName		db "listbox",0
CboxClName		db "combobox",0
ReditClName		db "richedit",0
RichEditLib		db "riched32.dll",0
Caption			db "Form",0
;_______________
.code
start:
	PUSH 3A32DC9Ch
	nop 
	nop
	nop	
	push AX
	pop BX
	push CX
	pop DX
	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	invoke	GetCommandLine
	invoke	WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke	ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc	:WNDCLASSEX
LOCAL msg 	:MSG
LOCAL hwnd	:HWND
	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_BYTEALIGNCLIENT
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,NULL
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszClassName,OFFSET ClassName
	invoke	LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke	RegisterClassEx,addr wc
invoke CreateWindowEx,0,ADDR ClassName,ADDR Caption,WS_SYSMENU or WS_MINIMIZEBOX,350,80,315,213,0,0,hInst,0
	mov		hwnd,eax
	INVOKE	ShowWindow,hwnd,SW_SHOWNORMAL
	INVOKE	UpdateWindow,hwnd
	.WHILE TRUE
		invoke	GetMessage,ADDR msg,0,0,0
		.BREAK .IF (!eax)
		invoke	TranslateMessage,ADDR msg
		invoke	DispatchMessage,ADDR msg
	.ENDW
 	mov	eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hdc:		HDC
LOCAL ps:		PAINTSTRUCT
	.IF uMsg == WM_DESTROY
		invoke	PostQuitMessage,NULL
	.ELSEIF uMsg == WM_PAINT
		invoke	BeginPaint,hWnd,ADDR ps
		mov		hdc,eax
		invoke	CreatePen,PS_SOLID,1,00000000h	;shape1
		invoke	SelectObject,hdc,eax			;shape1
		invoke	CreateSolidBrush,00FFFFFFh		;shape1
		invoke	SelectObject,hdc,eax			;shape1
		invoke	Rectangle,hdc,0,0,180,180
			invoke	CreatePen,PS_SOLID,1,000000FFh	;shape1
		invoke	SelectObject,hdc,eax			;shape1
		invoke	CreateSolidBrush,00FFFFFFh		;shape1
		invoke	SelectObject,hdc,eax			;shape1
		invoke MoveToEx,hdc,0,90,0
       		invoke LineTo,hdc,180,90
		invoke	EndPaint,hWnd,ADDR ps
	.ELSEIF uMsg == WM_CREATE
		invoke	lstrcpy,addr lf.lfFaceName,addr FontName
		mov		lf.lfHeight,-11
		mov		lf.lfWeight,500
		invoke	CreateFontIndirect,addr lf
		mov		hFontN,eax
invoke CreateWindowEx,0,ADDR BtnClName,ADDR Textbutton1,WS_CHILD or BS_DEFPUSHBUTTON or WS_VISIBLE,184,8,75,25,hWnd,button1ID,hInstance,0
		mov		hwndbutton1,eax
		invoke	SendMessage,hwndbutton1,WM_SETFONT,hFontN,1
	.ELSEIF uMsg == WM_COMMAND
		mov	eax,wParam
		.IF lParam != 0
			.IF ax == button1ID
				shr eax,16
				.IF ax == BN_CLICKED
					invoke ColorDialog,hWnd,hInstance,0   ; CC_FULLOPEN
					;invoke	MessageBox,hWnd,addr Textbutton1,0,MB_ICONINFORMATION
				.ENDIF
			.ENDIF
		.ENDIF;
	.ELSE
		invoke	DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor		eax,eax
	ret
WndProc endp
ColorDialog proc hWin:DWORD, instance:DWORD, Flags:DWORD

    LOCAL ccl:CHOOSECOLOR
    LOCAL crv[16]:DWORD

    lea edi, crv[0]
    mov ecx, 16
    mov eax, 0FFFFFFh
    rep stosd

    mov ccl.lStructSize,    sizeof CHOOSECOLOR
    push hWin
    pop ccl.hwndOwner 
    push instance
    pop ccl.hInstance
    mov ccl.rgbResult,      0
    lea eax, crv                ; address of 16 item DWORD array
    mov ccl.lpCustColors,   eax
    push Flags
    pop ccl.Flags
    mov ccl.lCustData,      0
    mov ccl.lpfnHook,       0
    mov ccl.lpTemplateName, 0

    invoke ChooseColor,ADDR ccl

    .if eax != 0
      mov eax, ccl.rgbResult
    .endif

    ret

ColorDialog endp
end start